//
// $Id: CrowdPeerDispatcher.java 6214 2010-10-18 18:01:12Z dhoover $
//
// Narya library - tools for developing networked games
// Copyright (C) 2002-2010 Three Rings Design, Inc., All Rights Reserved
// http://code.google.com/p/narya/
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

package com.threerings.crowd.peer.server;

import javax.annotation.Generated;

import com.threerings.crowd.chat.client.ChatService;
import com.threerings.crowd.chat.data.UserMessage;
import com.threerings.crowd.peer.data.CrowdPeerMarshaller;
import com.threerings.presents.data.ClientObject;
import com.threerings.presents.server.InvocationDispatcher;
import com.threerings.presents.server.InvocationException;
import com.threerings.util.Name;

/**
 * Dispatches requests to the {@link CrowdPeerProvider}.
 */
@Generated(value={"com.threerings.presents.tools.GenServiceTask"},
           comments="Derived from CrowdPeerService.java.")
public class CrowdPeerDispatcher extends InvocationDispatcher<CrowdPeerMarshaller>
{
    /**
     * Creates a dispatcher that may be registered to dispatch invocation
     * service requests for the specified provider.
     */
    public CrowdPeerDispatcher (CrowdPeerProvider provider)
    {
        this.provider = provider;
    }

    @Override
    public CrowdPeerMarshaller createMarshaller ()
    {
        return new CrowdPeerMarshaller();
    }

    @Override
    public void dispatchRequest (
        ClientObject source, int methodId, Object[] args)
        throws InvocationException
    {
        switch (methodId) {
        case CrowdPeerMarshaller.DELIVER_BROADCAST:
            ((CrowdPeerProvider)provider).deliverBroadcast(
                source, (Name)args[0], ((Byte)args[1]).byteValue(), (String)args[2], (String)args[3]
            );
            return;

        case CrowdPeerMarshaller.DELIVER_TELL:
            ((CrowdPeerProvider)provider).deliverTell(
                source, (UserMessage)args[0], (Name)args[1], (ChatService.TellListener)args[2]
            );
            return;

        default:
            super.dispatchRequest(source, methodId, args);
            return;
        }
    }
}
